/***********************************************************
  文件名：09_Potentiometer.ino
  描述：电位器控制led灯,并打印电位器电压值及led亮度值
  作者：陈志强
  日期：2022.11.3
***********************************************************/

float Voltage;//定义电压变量
float data;//定义电位器模拟值变量
int light;//定义LED灯亮度变量

void setup() {
  Serial.begin(9600);//设置串口波特率
  pinMode(A0, INPUT);//电位器电压输出接口
  pinMode(6, OUTPUT);
}

void loop() {
  data = analogRead(A0);//获取电位器电压模拟值
  Voltage = (data / 978) * 5;//模拟值和数字值转换 * 电压得到当前电压，模拟正常最大为1023，978为实际电位器模拟值最大值
  light = (map(constrain(analogRead(A0), 0, 978), 0, 978, 0, 255));//将电位器电压模拟值缩放至light变量以符合模拟输出取值范围，正常模拟输出PWM波取值为0-255
  Serial.print("Voltage is:");
  Serial.print(Voltage);//打印获取到的电压
  Serial.print("V");
  Serial.print("    light is:");//打印LED的亮度值
  Serial.println(light);
  analogWrite(6, light);//将light值转变为PWM波占空比从6号口输出。
  delay(100); //延时0.1秒

}
